
{******************************************}
{                                          }
{             FastScript v1.8              }
{              Basic grammar               }
{                                          }
{ (c) 2003, 2004 by Alexander Tzyganenko,  }
{             Fast Reports, Inc            }
{                                          }
{******************************************}

unit fs_ibasic;

interface

{$i fs.inc}

uses
  SysUtils, Classes, fs_itools;

type
  TfsBasic = class(TComponent);


implementation

const
  BASIC_GRAMMAR = 
  '<?xml version="1.0"?><language text="BasicScript"><parser><commentline1 ' +
  'text="''"/><commentline2 text="rem"/><commentblock1 text="/\,/\"/><comme' +
  'ntblock2 text="/\,/\"/><stringquotes text="&#34;"/><hexsequence text="0x' +
  '"/><declarevars text="0"/><skipeol text="0"/><skipchar text="_"/><keywor' +
  'ds><addressof/><and/><as/><byref/><byval/><case/><catch/><delete' +
  '/><dim/><do/><else/><elseif/><end/><endif/><exit/><finally/><for/><funct' +
  'ion/><if/><imports/><is/><loop/><mod/><new/><next/><not/><or/><rem/><ret' +
  'urn/><select/><set/><step/><sub/><then/><to/><try/><wend/><while/><with/' +
  '><xor/></keywords><errors><err1 text="Identifier expected"/><err2 text="' +
  'Expression expected"/><err3 text="End of line expected"/><err4 text="'':' +
  ''' expected"/><err5 text="'';'' expected"/><err6 text="''.'' expected"/>' +
  '<err7 text="'')'' expected"/><err8 text="'']'' expected"/><err9 text="''' +
  '='' expected"/><err10 text="''TO'' expected"/><err11 text="''END'' expec' +
  'ted"/><err12 text="''('' expected"/><err13 text="''THEN'' expected"/><er' +
  'r14 text="''WHILE'' expected"/><err15 text="''CASE'' expected"/><err16 t' +
  'ext="''SELECT'' expected"/><err17 text="''FINALLY'' or ''CATCH'' expecte' +
  'd"/><err18 text="''['' expected"/><err19 text="''..'' expected"/><err20 ' +
  'text="''&#62;'' expected"/><err21 text="''WEND'' expected"/><err22 text=' +
  '"''NEXT'' expected"/><err23 text="''WITH'' expected"/><err24 text="''TRY' +
  ''' expected"/><err25 text="''SUB'' expected"/><err26 text="''FUNCTION'' ' +
  'expected"/><err27 text="''ELSE'' expected"/><err28 text="''IF'' expected' +
  '"/></errors></parser><types><decimal type="extended"/></types><empty/><p' +
  'rogram><statements/></program><statements node="compoundstmt"><loop><swi' +
  'tch><eol/><sequence><statementlist/><eol err="err3"/></sequence></switch' +
  '></loop></statements><statementlist><loop text=":"><statement/></loop></' +
  'statementlist><importstmt node="uses"><keyword text="IMPORTS"/><loop tex' +
  't=","><string add="file" err="err1"/></loop></importstmt><dimstmt><keywo' +
  'rd text="DIM"/><loop text=","><vardecl/></loop></dimstmt><vardecl node="' +
  'var"><ident add="ident" err="err1" term="1"/><optional><array/></optiona' +
  'l><optional><asclause/></optional><optional><initvalue/></optional></var' +
  'decl><asclause><keyword text="AS"/><ident add="type" err="err1"/></ascla' +
  'use><array node="array"><char text="["/><loop text=","><arraydim err="er' +
  'r2"/></loop><char text="]" err="err8"/></array><arraydim node="dim"><exp' +
  'ression/></arraydim><initvalue node="init"><char text="="/><expression e' +
  'rr="err2"/></initvalue><expression node="expr"><simpleexpression/><optio' +
  'nalloop><relop/><simpleexpression/></optionalloop></expression><simpleex' +
  'pression><optional><char text="-" add="op" addtext="unminus"/></optional' +
  '><term/><optionalloop><addop/><term/></optionalloop></simpleexpression><' +
  'term><factor/><optionalloop><mulop/><factor/></optionalloop></term><fact' +
  'or><switch><designator/><number add="number"/><string add="string"/><seq' +
  'uence><char text="(" add="op"/><expression err="err2"/><char text=")" ad' +
  'd="op" err="err7"/></sequence><sequence><keyword text="NOT" add="op" add' +
  'text="not"/><factor err="err2"/></sequence><sequence><char text="["/><se' +
  'tconstructor err="err2"/><char text="]" err="err8"/></sequence><newopera' +
  'tor/><sequence><char text="&#60;"/><frstring/><char text="&#62;" err="er' +
  'r20"/></sequence></switch></factor><setconstructor node="set"><loop text' +
  '=","><setnode/></loop></setconstructor><setnode><expression/><optional><' +
  'char text="."/><char text="." add="range"/><expression/></optional></set' +
  'node><newoperator node="new"><keyword text="NEW"/><designator err="err2"' +
  '/></newoperator><relop><switch><sequence><char text="&#62;"/><char text=' +
  '"=" skip="0" add="op" addtext="&#62;="/></sequence><sequence><char text=' +
  '"&#60;"/><char text="&#62;" skip="0" add="op" addtext="&#60;&#62;"/></se' +
  'quence><sequence><char text="&#60;"/><char text="=" skip="0" add="op" ad' +
  'dtext="&#60;="/></sequence><char text="&#62;" add="op" addtext="&#62;"/>' +
  '<char text="&#60;" add="op" addtext="&#60;"/><char text="=" add="op" add' +
  'text="="/><keyword text="IN" add="op" addtext="in"/><keyword text="IS" a' +
  'dd="op" addtext="is"/></switch></relop><addop><switch><char text="+" add' +
  '="op"/><char text="-" add="op"/><char text="&#38;" add="op" addtext="str' +
  'cat"/><keyword text="OR" add="op" addtext="or"/><keyword text="XOR" add=' +
  '"op" addtext="xor"/></switch></addop><mulop><switch><char text="*" add="' +
  'op"/><char text="/" add="op"/><char text="\" add="op" addtext="div"/><ke' +
  'yword text="MOD" add="op" addtext="mod"/><keyword text="AND" add="op" ad' +
  'dtext="and"/></switch></mulop><designator node="dsgn"><optional><keyword' +
  ' text="ADDRESSOF" add="addr"/></optional><ident add="node"/><optionalloo' +
  'p><switch><sequence><char text="."/><keyword add="node"/></sequence><seque' +
  'nce><char text="[" add="node"/><exprlist err="err2"/><char text="]" err=' +
  '"err8"/></sequence><sequence><char text="("/><optional><exprlist/></opti' +
  'onal><char text=")" err="err7"/></sequence></switch></optionalloop></des' +
  'ignator><exprlist><loop text=","><expression/></loop></exprlist><stateme' +
  'nt><switch><breakstmt/><casestmt/><continuestmt/><deletestmt/><dimstmt/>' +
  '<dostmt/><exitstmt/><forstmt/><funcstmt/><ifstmt/><importstmt/><procstmt' +
  '/><returnstmt/><setstmt/><trystmt/><whilestmt/><withstmt/><assignstmt/><' +
  'callstmt/></switch></statement><breakstmt><keyword text="BREAK" node="br' +
  'eak"/></breakstmt><continuestmt><keyword text="CONTINUE" node="continue"' +
  '/></continuestmt><exitstmt><keyword text="EXIT" node="exit"/></exitstmt>' +
  '<deletestmt node="delete"><keyword text="DELETE"/><designator err="err2"' +
  '/></deletestmt><setstmt node="delete"><keyword text="SET"/><assignstmt e' +
  'rr="err2"/></setstmt><assignstmt node="assignstmt"><designator/><switch>' +
  '<sequence><char text="+" add="modificator"/><char text="=" skip="0"/></s' +
  'equence><sequence><char text="-" add="modificator"/><char text="=" skip=' +
  '"0"/></sequence><sequence><char text="*" add="modificator"/><char text="' +
  '=" skip="0"/></sequence><sequence><char text="/" add="modificator"/><cha' +
  'r text="=" skip="0"/></sequence><char text="="/></switch><expression err' +
  '="err2"/></assignstmt><callstmt node="callstmt"><designator/><optionalsw' +
  'itch><sequence><char text="+"/><char text="+" skip="0" add="modificator"' +
  '/></sequence><sequence><char text="-"/><char text="-" skip="0" add="modi' +
  'ficator"/></sequence></optionalswitch></callstmt><returnstmt node="retur' +
  'n"><keyword text="RETURN"/><optional><expression/></optional></returnstm' +
  't><ifstmt node="ifstmt"><keyword text="IF"/><expression err="err2"/><key' +
  'word text="THEN" err="err13"/><thenstmt/></ifstmt><thenstmt><switch><seq' +
  'uence><eol/><optional><statements node="thenstmt"/></optional><optionals' +
  'witch><elseifstmt node="elsestmt"/><elsestmt node="elsestmt"/></optional' +
  'switch><keyword text="END" err="err11"/><keyword text="IF" err="err28"/>' +
  '</sequence><statementlist node="thenstmt"/></switch></thenstmt><elseifst' +
  'mt node="ifstmt"><keyword text="ELSEIF"/><expression err="err2"/><keywor' +
  'd text="THEN" err="err13"/><switch><sequence><eol/><optional><statements' +
  ' node="thenstmt"/></optional><optionalswitch><elseifstmt node="elsestmt"' +
  '/><elsestmt node="elsestmt"/></optionalswitch></sequence><statement node' +
  '="thenstmt"/></switch></elseifstmt><elsestmt><keyword text="ELSE"/><swit' +
  'ch><sequence><eol/><optional><statements/></optional></sequence><stateme' +
  'nt/></switch></elsestmt><casestmt node="casestmt"><keyword text="SELECT"' +
  '/><keyword text="CASE" err="err15"/><expression err="err2"/><eol/><loop>' +
  '<caseselector/></loop><optional><keyword text="CASE"/><keyword text="ELS' +
  'E" err="err27"/><char text=":" err="err4"/><statements/></optional><keyw' +
  'ord text="END" err="err11"/><keyword text="SELECT" err="err16"/></casest' +
  'mt><caseselector node="caseselector"><keyword text="CASE"/><setconstruct' +
  'or/><char text=":" err="err4"/><statements/></caseselector><dostmt node=' +
  '"repeatstmt"><keyword text="DO"/><optional><statements/></optional><keyw' +
  'ord text="LOOP"/><switch><sequence><keyword text="UNTIL"/><expression er' +
  'r="err2"/></sequence><sequence><keyword text="WHILE" err="err14"/><expre' +
  'ssion err="err2"/><empty add="inverse"/></sequence></switch></dostmt><wh' +
  'ilestmt node="whilestmt"><keyword text="WHILE"/><expression err="err2"/>' +
  '<optional><statements/></optional><keyword text="WEND" err="err21"/></wh' +
  'ilestmt><forstmt node="vbforstmt"><keyword text="FOR"/><ident add="ident' +
  '" err="err1"/><char text="=" err="err9"/><expression err="err2"/><keywor' +
  'd text="TO" err="err10"/><expression err="err2"/><optional><keyword text' +
  '="STEP"/><expression err="err2"/></optional><eol/><optional><statements/' +
  '></optional><keyword text="NEXT" err="err22"/></forstmt><trystmt node="t' +
  'rystmt"><keyword text="TRY"/><statements/><switch err="err17"><sequence>' +
  '<keyword text="FINALLY"/><optional><statements node="finallystmt"/></opt' +
  'ional></sequence><sequence><keyword text="CATCH"/><optional><statements ' +
  'node="exceptstmt"/></optional></sequence></switch><keyword text="END"/><' +
  'keyword text="TRY" err="err24"/></trystmt><withstmt node="with"><keyword' +
  ' text="WITH"/><designator err="err2"/><eol/><statements/><keyword text="' +
  'END"/><keyword text="WITH" err="err23"/></withstmt><procstmt node="proce' +
  'dure"><keyword text="SUB"/><ident add="name" err="err1"/><optional><form' +
  'alparameters/></optional><eol/><optional><statements/></optional><keywor' +
  'd text="END"/><keyword text="SUB" err="err25"/></procstmt><funcstmt node' +
  '="function"><keyword text="FUNCTION"/><ident add="name" err="err1"/><opt' +
  'ional><formalparameters/></optional><optional><asclause/></optional><eol' +
  '/><optional><statements/></optional><keyword text="END"/><keyword text="' +
  'FUNCTION" err="err26"/></funcstmt><formalparameters node="parameters"><c' +
  'har text="("/><optionalloop text=","><formalparam/></optionalloop><char ' +
  'text=")" err="err7"/></formalparameters><formalparam><optionalswitch><ke' +
  'yword text="BYREF" node="varparams"/><keyword text="BYVAL"/></optionalsw' +
  'itch><vardecl/></formalparam></language>';

initialization
  fsRegisterLanguage('BasicScript', BASIC_GRAMMAR);

end.
